Package org.apache.lucene.search

## Class FieldExistsQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.search.FieldExistsQuery

- Direct Known Subclasses:
    `DocValuesFieldExistsQuery`, `KnnVectorFieldExistsQuery`, `NormsFieldExistsQuery`

      public class FieldExistsQuery
      extends Query

  A `Query` that matches documents that contain either a `KnnVectorField`, or a field that indexes norms or doc values.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FieldExistsQuery​(String field)` | Create a query that will match that have a value for the given `field`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Weight` | `createWeight​(IndexSearcher searcher, ScoreMode scoreMode, float boost)` | Expert: Constructs an appropriate Weight implementation for this query.
    `boolean` | `equals​(Object other)` | Override and implement query instance equivalence properly in a subclass.
    `static DocIdSetIterator` | `getDocValuesDocIdSetIterator​(String field, LeafReader reader)` | Returns a `DocIdSetIterator` from the given field or null if the field doesn't exist in the reader or if the reader has no doc values for the field.
    `String` | `getField()` |
    `int` | `hashCode()` | Override and implement query hash code properly in a subclass.
    `Query` | `rewrite​(IndexReader reader)` | Expert: called to re-write queries into primitive queries.
    `String` | `toString​(String field)` | Prints a query to a string, with `field` assumed to be the default field and omitted.
    `void` | `visit​(QueryVisitor visitor)` | Recurse through the query tree, visiting any child queries

    - ### Methods inherited from class org.apache.lucene.search.Query

      `classHash, sameClassAs, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FieldExistsQuery

          public FieldExistsQuery​(String field)

      Create a query that will match that have a value for the given `field`.

  - ### Method Detail

    - #### getDocValuesDocIdSetIterator

          public static DocIdSetIterator getDocValuesDocIdSetIterator​(String field,
                                                                      LeafReader reader)
                                                               throws IOException

      Returns a `DocIdSetIterator` from the given field or null if the field doesn't exist in the reader or if the reader has no doc values for the field.
      Throws:
        `IOException`

    - #### getField

          public String getField()

    - #### toString

          public String toString​(String field)

      Description copied from class: `Query`
      Prints a query to a string, with `field` assumed to be the default field and omitted.
      Specified by:
        `toString` in class `Query`

    - #### visit

          public void visit​(QueryVisitor visitor)

      Description copied from class: `Query`
      Recurse through the query tree, visiting any child queries
      Specified by:
        `visit` in class `Query`
      Parameters:
        `visitor` - a QueryVisitor to be called by each query in the tree

    - #### equals

          public boolean equals​(Object other)

      Description copied from class: `Query`
      Override and implement query instance equivalence properly in a subclass. This is required so that `QueryCache` works properly.

      Typically a query will be equal to another only if it's an instance of the same class and its document-filtering properties are identical that other instance. Utility methods are provided for certain repetitive code.

      Specified by:
        `equals` in class `Query`
      See Also:
        `Query.sameClassAs(Object)`, `Query.classHash()`

    - #### hashCode

          public int hashCode()

      Description copied from class: `Query`
      Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.
      Specified by:
        `hashCode` in class `Query`
      See Also:
        `Query.equals(Object)`

    - #### rewrite

          public Query rewrite​(IndexReader reader)
                        throws IOException

      Description copied from class: `Query`
      Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

      Callers are expected to call `rewrite` multiple times if necessary, until the rewritten query is the same as the original query.

      Overrides:
        `rewrite` in class `Query`
      Throws:
        `IOException`
      See Also:
        `IndexSearcher.rewrite(Query)`

    - #### createWeight

          public Weight createWeight​(IndexSearcher searcher,
                                     ScoreMode scoreMode,
                                     float boost)

      Description copied from class: `Query`
      Expert: Constructs an appropriate Weight implementation for this query.

      Only implemented by primitive queries, which re-write to themselves.

      Overrides:
        `createWeight` in class `Query`
        `scoreMode` - How the produced scorers will be consumed.
        `boost` - The boost that is propagated by the parent queries.